import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provinceJahadSubmitAllocationService = createAsyncThunk(
  "PROVINCE_JAHAD_SUBMIT_ALLOCATION_SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.post(
        "LiveStock/jahad/live-stock-allocation/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceJahadEditAllocationService = createAsyncThunk(
  "PROVINCE_JAHAD_EDIT_ALLOCATION_SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.put(
        "/LiveStock/jahad/live-stock-allocation/0/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceJahadDeleteAllocationService = createAsyncThunk(
  "PROVINCE_JAHAD_DELETE_ALLOCATION",
  async (id, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        "LiveStock/jahad/live-stock-allocation/0/?allocation_key=" + id
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
